﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Xml;
using System.Xml.Linq;
using Syncfusion.Mvc.Shared;
using System.Web.Script.Serialization;

namespace AutoCompleteDropDown.Controllers
{

    public class HomeController : Controller
    {
        AutocompleteTextBoxModel countryModel = new AutocompleteTextBoxModel();
        AutocompleteTextBoxModel stateModel = new AutocompleteTextBoxModel();
        AutocompleteTextBoxModel cityModel = new AutocompleteTextBoxModel();

        public ActionResult Index()
        {
            countryModel.WaterMark = "[Select Country]";
            countryModel.DataSource = GetCountry();
            ViewData["MyCountry"] = countryModel;
            stateModel.WaterMark = "[Select State]";
            ViewData["MyState"] = stateModel;
            cityModel.WaterMark = "[Select City]";
            ViewData["MyCity"] = cityModel;
            return View();
        }
        public List<string> GetCountry()
        {
            XmlDocument xd = new XmlDocument();
            xd.Load(Request.PhysicalApplicationPath + "App_Data\\Sample.xml");
            XmlNodeList country_li = xd.GetElementsByTagName("Country");
            XmlNodeList state_li = country_li[1].ChildNodes;
            List<string> country = new List<string>();
            for (int i = 0; i < country_li.Count; i++)
            {
                country.Add(country_li[i].Attributes["Text"].Value);
            }
           return country;
        }

        public ActionResult GetStates(string Country)
        {
            List<string> states = new List<string>();
            if (!string.IsNullOrEmpty(Country))
            {
                XElement doc1 = XElement.Load(Request.PhysicalApplicationPath + "App_Data\\Sample.xml");
                var list = doc1.Elements("Products").Elements("Country").ToList();
                for (int i = 0; i < list.Count; i++)
                {
                    if (list[i].LastAttribute.Value == Country)
                    {

                        var state_li = list[i].Elements("State").ToList();
                        for (int j = 0; j < state_li.Count; j++)
                        {
                            states.Add(state_li[j].Attribute("Text").Value.ToString());

                        }
                    }
                }
            }
            return Json(states.ToList()) ;
        }

        public ActionResult GetCities(string selCity)
        {
            List<string> cities = new List<string>();
            if (!string.IsNullOrEmpty(selCity))
            {
                XElement doc1 = XElement.Load(Request.PhysicalApplicationPath + "App_Data\\Sample.xml");
                var state1 = doc1.Elements("Products").Elements("Country").Elements("State").ToList();
                for (int i = 0; i < state1.Count; i++)
                {
                    if (state1[i].LastAttribute.Value == selCity)
                    {

                        var city_li = state1[i].Elements("City").ToList();
                        for (int j = 0; j < city_li.Count; j++)
                        {
                            cities.Add(city_li[j].Attribute("Text").Value.ToString());

                        }
                    }
                }
            }

            return Json(cities.ToList());
        }

    }
}
