﻿
/*  AutocompleteTextBox_Prototype
*  This JavaScript file is Prototype model of Autocomplete TextBox
*/

Type.registerNamespace("Syncfusion.Mvc.Shared");

Syncfusion.Mvc.Shared.AutocompleteTextBox = function (element) {
    Syncfusion.Mvc.Shared.AutocompleteTextBox.initializeBase(this, [element]);
    this._ID = null;
    this._textBox = null;
    this._queryString = null;
    this._suggestionID = null;
    this._suggestion = null;
    this._timeOut = null;
    this._currentList = null;
    this._form = null;
    this._activeItem = null;
    this._listSize = null;
    this._proxySuggestion = null;
    this._ListSize = null;
    this._MinCharacter = 1;
    this._RequestMapper = null;
    this._FilterType = null;
    this._Delay = null;
    this._DataFetch = null;
    this._CaseSensitive = false;
    this._JSONMode = true;
    this._Mode = null;
    this._ListWidth = null;
    this._CssClass = null;
    this._ClientSideTemplate = null;
    this._LoadingImage = null;
    this._proxyTemplate = null;
    this._suggestionListID = null;
    this._ListHeight = null;
    this._WaterMark = null;
    this._DropDown = null;
    this._AllowCache = null;
    this._Delimiter = null;
    this._Value = null;
    this.Error = false;
    this._zIndex = 1000;
    this._DataSource = null
    this._HighlightItemIndex = null;
    this._HighlightTextCss = null;
    this._HighlightTypedString = true;
    this._ListXPosition = null;
    this._ListYPosition = null;
    this._RightToLeft = false;
    this._AutoFill = false;
    this._Disable = null;
    this._Hide = null;
    this._FillOnMouseOver = false;
}

Syncfusion.Mvc.Shared.AutocompleteTextBox.prototype = {
    initialize: function () {
        ///Construtor
        Syncfusion.Mvc.Shared.AutocompleteTextBox.callBaseMethod(this, "initialize");
        this._renderSuggestionList();
        this._initObjects();
        this._wireEvents();
        this._onLoaded();
    },
    dispose: function () {
        ///Destructor
        this._disposeEvents();
        Syncfusion.Mvc.Shared.AutocompleteTextBox.callBaseMethod(this, "dispose");

    },
    //After the control gets loaded
    _onLoaded: function () {
        if ($get(this.get_ClientSideTemplate())) {
            $("#" + this.get_ClientSideTemplate()).css({ "visibility": "visible" });
        }
        if (this.get_Disable())
            this.Disable();
        if (this.get_Hide())
            this.Hide();
        this._raiseEventRendering("ClientSideOnLoad", null, $(this._mainDiv)[0]);
    },
    /* Initialize the Objects*/
    _initObjects: function () {
        this._currentList = 0;

        this._wholeQuery = null;
        this._delimiterIndex = null;
        this._queryLength = null;
        this._delimiterFlag = 0;

        this._dropdownFlag = false;
        this._activeItem = 0;
        this._listHeight = 150;
        this._suggestionLength = 0;
        this._textBox = "#" + this._ID;
        this._wrapperDiv = "#" + this._ID + "_actextbox";
        this._wrapperID = this._ID + "_actextbox";
        this._suggestionClass = "sf-autocomplete Autocomplete_SuggestionList";
        this._suggestionID = "#" + this._ID + "_suggestion";
        this._suggestionWrapper = $get(this._ID + "_suggestion_wrapper");
        this._proxyTemplate = "#clientside-template";
        this._suggestionListID = this._suggestionID + " ul li";
        this._mainDiv = "#" + this._ID + "_actextbox";
        this._dropdownButton = "#" + this._ID + "_dropdownbutton";
        this._form = $(this._element).parents().find("form");

        // set width for textbox if dropdown enabled
        if (this._DropDown) {
            var width = $(this._wrapperDiv).width() - $(this._dropdownButton)[0].offsetWidth;
            $(this._textBox).css("width", width + "px");
        }

        /* Set WaterMark or Default Value to the TextBox*/
        if (this.get_WaterMark() != null && (!this.get_Value())) {
          $(this._textBox).addClass("watermark").val(this._WaterMark);
        }
        else if (this.get_Value())
            $(this._textBox).val(this.get_Value());

        //Check If Error Flag is true add the css class
        if (this.get_Error() == true) {
            $(this._textBox).addClass("error");
        }
    },
    /* Set the Suggestion List Width size*/
    set_listWidth: function () {
        if (this.get_ListWidth())
            $(this._suggestionID).width(this.get_ListWidth());
        else {
            var _textboxWidth = $(this._wrapperDiv).width();
            $(this._suggestionID).width(_textboxWidth);
        }
    },
    /* Set the Suggestion List Width size*/
    set_listHeight: function () {
        if (this.get_ListHeight()) {
            $(this._suggestionID).height(this.get_ListHeight());
        }
        else {
            $(this._suggestionID).css({ "max-height": "100px" });
        }
    },
    /* public method for resetting ZIndex */
    ResetZIndex: function () {
        this._zIndex = Math.max.apply(null, $.map($('body *'), function (e, n) {
            if ($(e).css('position') == 'absolute')
                return parseInt($(e).css('z-index')) || 1;
        })
	    );
        if (this._zIndex == undefined || this._zIndex == null)
            this._zIndex = 1;
    },
    /* Set the Suggestion List Position */
    set_listPosition: function () {
        var pos = $(this._mainDiv).offset();
        var totalHeight = $(this._mainDiv).outerHeight();
        var border = (totalHeight - $(this._mainDiv).height()) / 2;
        var maxZ = $(this._element).closest('.ui-dialog').css('z-index');
        if (maxZ != null)
            this._zIndex = parseInt(maxZ, 10) + 2;
        else
            this._zIndex = this._zIndex;

        if (this.get_ListXPosition() != -1 && this.get_ListYPosition() != -1)
            $(this._suggestionID).css({ "left": this.get_ListXPosition() + "px", "top": this.get_ListYPosition() + "px", "z-index": this._zIndex });
        else
            $(this._suggestionID).css({ "left": pos.left + "px", "top": pos.top + totalHeight - border + "px", "z-index": this._zIndex });
    },
    /* Properties */
    get_FilterType: function () {
        return this._FilterType;
    },
    set_FilterType: function (value) {
        this._FilterType = value;
    },
    get_Value: function () {
        return this._Value;
    },
    set_Value: function (value) {
        this._Value = value;
    },
    get_Delimiter: function () {
        return this._Delimiter;
    },
    set_Delimiter: function (value) {
        this._Delimiter = value;
    },
    set_AllowCache: function (value) {
        this._AllowCache = value;
    },
    get_AllowCache: function () {
        return this._AllowCache;
    },
    get_WaterMark: function () {
        return this._WaterMark;
    },
    set_WaterMark: function (value) {
        this._WaterMark = value;
    },
    get_DropDown: function () {
        return this._DropDown;
    },
    set_DropDown: function (value) {
        this._DropDown = value;
    },
    get_ListWidth: function () {
        return this._ListWidth;
    },
    set_ListWidth: function (value) {
        this._ListWidth = value;
    },
    get_ListHeight: function () {
        return this._ListHeight;
    },
    set_ListHeight: function (value) {
        this._ListHeight = value;
    },
    get_ListSize: function () {
        return this._ListSize;
    },
    set_ListSize: function (value) {
        this._ListSize = value;
    },
    get_LoadingImage: function () {
        return this._LoadingImage;
    },
    set_LoadingImage: function (value) {
        this._LoadingImage = value;
    },
    get_ClientSideTemplate: function () {
        return this._ClientSideTemplate;
    },
    set_ClientSideTemplate: function (value) {
        this._ClientSideTemplate = value;
    },
    get_ID: function () {
        return this._ID;
    },
    set_ID: function (value) {
        this._ID = value;
    },
    get_DataFetch: function () {
        return this._DataFetch;
    },
    set_DataFetch: function (value) {
        this._DataFetch = value;
    },
    get_RequestMapper: function () {
        return this._RequestMapper;
    },
    set_RequestMapper: function (value) {
        this._RequestMapper = value;
    },
    get_MinCharacter: function () {
        return this._MinCharacter;
    },
    set_MinCharacter: function (value) {
        this._MinCharacter = value;
    },
    get_CaseSensitive: function () {
        return this._CaseSensitive;
    },
    set_CaseSensitive: function (value) {
        this._CaseSensitive = value;
    },
    get_JSONMode: function () {
        return this._JSONMode;
    },
    set_JSONMode: function (value) {
        this._JSONMode = value;
    },
    get_Mode: function () {
        return this._Mode;
    },
    set_Mode: function (value) {
        this._Mode = value;
    },
    get_CssClass: function () {
        return this._CssClass;
    },
    set_CssClass: function (value) {
        this._CssClass = value;
    },
    get_Delay: function () {
        return this._Delay;
    },
    set_Delay: function (value) {
        this._Delay = value;
    },
    /* Get and Set the Error Flag*/
    get_Error: function () {
        return this._Error;
    },
    set_Error: function (value) {
        this._Error = value;
    },
    get_DataSource: function () {
        return this._DataSource;
    },
    set_DataSource: function (value) {
        this._DataSource = value;
    },
    get_HighlightItemIndex: function () {
        return this._HighlightItemIndex;
    },
    set_HighlightItemIndex: function (value) {
        this._HighlightItemIndex = value;
    },
    get_HighlightTextCss: function () {
        return this._HighlightTextCss;
    },
    set_HighlightTextCss: function (value) {
        this._HighlightTextCss = value;
    },
    get_HighlightTypedString: function () {
        return this._HighlightTypedString;
    },
    set_HighlightTypedString: function (value) {
        this._HighlightTypedString = value;
    },
    get_ListXPosition: function () {
        return this._ListXPosition;
    },
    set_ListXPosition: function (value) {
        this._ListXPosition = value;
    },
    get_ListYPosition: function () {
        return this._ListYPosition;
    },
    set_ListYPosition: function (value) {
        this._ListYPosition = value;
    },
    get_RightToLeft: function () {
        return this._RightToLeft;
    },
    set_RightToLeft: function (value) {
        this._RightToLeft = value;
    },
    get_AutoFill: function () {
        return this._AutoFill;
    },
    set_AutoFill: function (value) {
        this._AutoFill = value;
    },
    get_Hide: function () {
        return this._Hide;
    },
    set_Hide: function (value) {
        this._Hide = value;
    },
    get_FillOnMouseOver: function () {
        return this._FillOnMouseOver;
    },
    set_FillOnMouseOver: function (value) {
        this._FillOnMouseOver = value;
    },
    get_Disable: function () {
        return this._Disable;
    },
    set_Disable: function (value) {
        this._Disable = value;
    },
    /* ClientSide Events*/
    add_ClientSideFocusIn: function (handler) {
        this.get_events().addHandler("ClientSideFocusIn", handler);
    },
    remove_ClientSideFocusIn: function (handler) {
        this.get_events().removeHandler("ClientSideFocusIn", handler);
    },
    add_ClientSideFocusOut: function (handler) {
        this.get_events().addHandler("ClientSideFocusOut", handler);
    },
    remove_ClientSideFocusOut: function (handler) {
        this.get_events().removeHandler("ClientSideFocusOut", handler);
    },
    add_ClientSideValueChange: function (handler) {
        this.get_events().addHandler("ClientSideValueChange", handler);
    },
    remove_ClientSideValueChange: function (handler) {
        this.get_events().removeHandler("ClientSideValueChange", handler);
    },
    add_ClientSideOnSelect: function (handler) {
        this.get_events().addHandler("ClientSideOnSelect", handler);
    },
    remove_ClientSideOnSelect: function (handler) {
        this.get_events().removeHandler("ClientSideOnSelect", handler);
    },
    add_ClientSideOnItemRendering: function (handler) {
        this.get_events().addHandler("ClientSideOnItemRendering", handler);
    },
    remove_ClientSideOnItemRendering: function (handler) {
        this.get_events().removeHandler("ClientSideOnItemRendering", handler);
    },
    add_ClientSideOnLoad: function (handler) {
        this.get_events().addHandler("ClientSideOnLoad", handler);
    },
    remove_ClientSideOnLoad: function (handler) {
        this.get_events().removeHandler("ClientSideOnLoad", handler);
    },
    add_ClientSideOnFiltering: function (handler) {
        this.get_events().addHandler("ClientSideOnFiltering", handler);
    },
    remove_ClientSideOnFiltering: function (handler) {
        this.get_events().removeHandler("ClientSideOnFiltering", handler);
    },
    add_ClientSideOnBeforeRequest: function (handler) {
        this.get_events().addHandler("ClientSideOnBeforeRequest", handler);
    },
    remove_ClientSideOnBeforeRequest: function (handler) {
        this.get_events().removeHandler("ClientSideOnBeforeRequest", handler);
    },
    add_ClientSideOnSuccess: function (handler) {
        this.get_events().addHandler("ClientSideOnSuccess", handler);
    },
    remove_ClientSideOnSuccess: function (handler) {
        this.get_events().removeHandler("ClientSideOnSuccess", handler);
    },
    add_ClientSideOnFailure: function (handler) {
        this.get_events().addHandler("ClientSideOnFailure", handler);
    },
    remove_ClientSideOnFailure: function (handler) {
        this.get_events().removeHandler("ClientSideOnFailure", handler);
    },
    add_ClientSideOnComplete: function (handler) {
        this.get_events().addHandler("ClientSideOnComplete", handler);
    },
    remove_ClientSideOnComplete: function (handler) {
        this.get_events().removeHandler("ClientSideOnComplete", handler);
    },

    /* No Suggestion List */
    _showNoSuggestion: function () {
        var suggestionDiv = document.createElement("div");
        suggestionDiv.id = this._ID + "_suggestion";
        suggestionDiv.className = this.get_CssClass();

        var ul = document.createElement("ul");
        var li = document.createElement("li");
        li.innerHTML = "No Suggestion";
        ul.appendChild(li);
        suggestionDiv.appendChild(ul);

        $(this._suggestionWrapper).append(suggestionDiv); //changes
        $(this._suggestionID).addClass(this._suggestionClass);
        this.set_listWidth();
        this.set_listPosition();
        this._showResult();
    },
    /* Shows the Suggestion List */
    _showResult: function () {
        $(this._suggestionID).slideDown();
        this._listSize = $(this._suggestionListID).size();
    },
    /* Hides the Suggestion List */
    _hideResult: function () {
        this._activeItem = 0;
        $(this._suggestionID).slideUp();
        $(this._suggestionID).remove();
    },
    _getActiveItem: function () {
        return $(this._suggestionID + " ul li:nth-child(" + this._activeItem + ")");
    },
    /* Hover on Suggestion List */
    _addListHover: function () {
        this._getActiveItem().addClass("listHover");
        (this._getActiveItem())[0].scrollIntoView(false);
        this._getActiveItem().focus();
    },
    /* Remove Hover effect on Suggestion List */
    _removeListHover: function () {
        $(this._suggestionListID).removeClass("listHover");
    },
    /* Set the Current value to Text Box */
    _setTextBoxValue: function () {
        var currentValue = this._getActiveItem().text();
        if (this._delimiterFlag)
            $(this._textBox).val(this._wholeQuery.substr(0, this._delimiterIndex + 1) + currentValue);
        else if (this.get_ClientSideTemplate())
            $(this._textBox).val(currentValue.trim().replace(new RegExp(" +", "g"), " ").replace(new RegExp("\n+", "g"), ""));
        else if (this._suggestion)
            $(this._textBox).val(currentValue);
        /* Raise ClientSide Event*/
        this._raiseEvents("ClientSideValueChange");
    },
    /* Add Loading Spin Class */
    _addLoadingClass: function () {
        if (this.get_LoadingImage())
            $(this._textBox).addClass("onLoading");
    },
    /* Remove Loading Spin Class */
    _removeLoadingClass: function () {
        $(this._textBox).removeClass("onLoading");
    },
    /* Render the Server side JSON data  */
    render_JSONData: function () {
        //debugger;
        this._hideResult();
        var listsize;
        this._suggestion = eval(this._suggestion);
        var div = document.createElement("DIV");
        div.id = this._ID + "_suggestion";
        div.className = this.get_CssClass();
        var ul = document.createElement("ul");
        this._suggestionLength = this._suggestion.length;
        if (!this.get_ListSize())
            listsize = this._suggestionLength;
        else
            listsize = this.get_ListSize();
        for (var i = 0; i < this._suggestionLength && i < listsize; i++) {
            var li = document.createElement("li");
            if ($("#" + this._ID).val() != "" && this._queryString == "")
                this._queryString = $("#" + this._ID).val()
            if (this._queryString != "" && this.get_HighlightTypedString())
                li.innerHTML = this._highlightPatch(this._suggestion[i]);
            else
                li.innerHTML = this._suggestion[i];
            ul.appendChild(li);
            this._raiseEventRendering("ClientSideOnItemRendering", this._suggestion[i], li);
        }
        if (ul.hasChildNodes()) {
            div.appendChild(ul);
            $(this._suggestionWrapper).append(div); //changes
            $(this._suggestionID).addClass(this._suggestionClass);
            /* Setting the List Height, Width and Position*/
            this.set_listHeight();
            this.set_listWidth();
            this.set_listPosition();
            this._showResult();
        }
        else {
            this._showNoSuggestion();
        }
    },
    /* Render the Client Side Template Data*/
    generate_Template: function () {

        this._hideResult();
        var listsize;
        this._suggestionLength = eval(this._suggestion).length;
        var data = eval(this._suggestion);
        if (!this.get_ListSize())
            listsize = this._suggestionLength;
        else
            listsize = this.get_ListSize();
        if (data != "") {
            //Making a clone of the template        
            if ($get(this.get_ClientSideTemplate()))
                $("#" + this.get_ClientSideTemplate()).clone().insertAfter("#" + this.get_ClientSideTemplate()).attr("id", "clientside-template");
            else
                $(this._proxyTemplate).clone().insertAfter(this._proxyTemplate).attr("id", this.get_ClientSideTemplate());
            var div = document.createElement("DIV");
            div.id = this._ID + "_suggestion";
            div.className = this.get_CssClass();
            div.appendChild($get(this.get_ClientSideTemplate()));
            $(this._suggestionWrapper).append(div); //changes
            $(this._suggestionID).addClass(this._suggestionClass);
            this.set_listHeight();
            this.set_listWidth();
            this.set_listPosition();
            $create(Sys.UI.DataView, { data: data.slice(0, listsize) }, null, null, $get(this.get_ClientSideTemplate()));
            this._showResult();
            //$find(req).set_data(nfcEast);
        } else {
            this._showNoSuggestion();
        }
    },
    /* Create ClientObject to Pass ActionResult */
    get_Clientobject: function () {
        var _clientObject = {
            ID: this._ID,
            QueryString: this._queryString,
            CaseSensitive: this.get_CaseSensitive(),
            DataFetch: this.get_DataFetch(),
            JSONMode: this.get_JSONMode(),
            AutoFormat: this.get_CssClass(),
            ListSize: this.get_ListSize(),
            FilterType: this.get_FilterType()
        };
        return Sys.Serialization.JavaScriptSerializer.serialize(_clientObject);
    },
    /* Sending Get request*/
    _sendGetRequest: function () {
        this._hideResult();
        this._addLoadingClass();
        var pointer = this;
        $.get(this.get_RequestMapper(),
         { QueryString: this._queryString },
         function (data) {
             pointer._removeLoadingClass();
             pointer._suggestion = data;
             if (pointer._dropdownFlag) {
                 pointer._proxySuggestion = data;
                 pointer._dropdownFlag = false;
             }
             // Check for ClientSideTemplate
             if (pointer.get_ClientSideTemplate())
                 pointer.generate_Template();
             else
                 pointer.render_JSONData();
             pointer._suggestionListProperties();
         });
    },
    /* Sending AJAX request*/
    _sendAjaxRequest: function () {
        var data = {
            ClientObject: this.get_Clientobject(),
            QueryString: this._queryString
        };
        this._raiseAjaxEvent("ClientSideOnBeforeRequest", data);
        var pointer = this;
        var dataType;
        $.ajax({
            type: 'Post',
            url: this.get_RequestMapper(),
            data: data,
            dataType: this.get_JSONMode() ? "JSON" : "html",
            beforeSend: this._OnRequest(),
            success: function (result) {
                pointer._raiseAjaxEvent("ClientSideOnSuccess", result);
                pointer._suggestion = result;
                if (pointer.get_ClientSideTemplate())
                    pointer.generate_Template();
                else
                    pointer._OnResponse();
                pointer._removeLoadingClass();
                pointer._suggestionListProperties();

            },
            complete: function (data) {
                pointer._raiseAjaxEvent("ClientSideOnComplete", data);
            },
            error: function (e) {
                pointer._raiseAjaxEvent("ClientSideOnFailure", e);
                pointer._removeLoadingClass();
                pointer._hideResult();
            }
        });
    },
    /* filter data in client Side */
    _fetchData: function () {
        // debugger;
        var caseSensitive = this.get_CaseSensitive() ? "g" : "i";
        this._suggestion = eval(this._suggestion);
        var tempQueryString = this.get_FilterType() == "StartsWith" ? "^" + this._queryString : this._queryString;
        var tempSuggestion = [];
        $(this._suggestion).each(function (i, val) {
            var RegEx = new RegExp(tempQueryString, caseSensitive);
            if (RegEx.test(val)) {
                tempSuggestion.push(val);
            }
        });
        var handler = this.get_events().getHandler("ClientSideOnFiltering");
        if (handler) {
            var eventArgs = {
                get_EventName: function () {
                    return "ClientSideOnFiltering";
                }, get_DataList: function () {
                    return this._suggestion;
                }, get_FilteredList: function () {
                    return tempSuggestion;
                }
            };
            if (!eventArgs) {
                eventArgs = Sys.EventArgs.Empty;
            }
            handler(this, eventArgs);
        }
        this._suggestion = tempSuggestion;
        if (this.get_ClientSideTemplate())
            this.generate_Template();
        else
            this._OnResponse();
        this._suggestionListProperties();
    },
    /* Highlight the typed text in suggestion List */
    _highlightPatch: function (suggestion) {
        var caseSensitive = this.get_CaseSensitive() ? "g" : "gi";
        var tempQueryString = this.get_FilterType() == "StartsWith" ? "^" + this._queryString : this._queryString;
        var RegEx = new RegExp(tempQueryString, caseSensitive);
        var cssName = "HighlightQueryText";
        if (this.get_HighlightTextCss() != null)
            cssName = this.get_HighlightTextCss();
        if (RegEx.test(suggestion)) {
            var mch = suggestion.match(RegEx);
            var split = suggestion.split(RegEx);
            suggestion = "";
            $(split).each(function (i, val) {
                if (mch[i])
                    suggestion += "<span class=" + cssName + ">" + mch[i] + "</span>" + val;
                else
                    suggestion += val;
            });
        }
        return suggestion;
    },
    /* Fill the first element in AutoComplete TextBox */
    _autoFill: function () {
        var input = $("#" + this._ID)[0];
        if (this._suggestion[0] && !this.get_ClientSideTemplate())
            this.get_HighlightItemIndex() > 0 && (this.get_HighlightItemIndex() - 1) < this._suggestion.length ? $(input).val(this._suggestion[this.get_HighlightItemIndex() - 1]) : $(input).val(this._suggestion[0]);
        else if (this.get_ClientSideTemplate()) {
            var value = $(this._suggestionID).find("li:first").attr("textContent").trim().replace(new RegExp(" +", "g"), " ").replace(new RegExp("\n+", "g"), "");
            $(input).val(value);
        }
        var val = $(input).val().search(new RegExp(this._queryString, "gi"));

        if (!($.browser.msie == true && $.browser.version < 9)) {
            input.setSelectionRange(val, val + this._queryString.length);
        }
        $(input).focus();
    },
    _suggestionListProperties: function () {
        if (this.get_RightToLeft()) {
            $("#" + this._ID).css("text-align", "right");
            $(this._suggestionID + " *").css("text-align", "right");
            $(this._suggestionID).css("direction", "rtl");
        }
        if (eval(this._suggestion) && eval(this._suggestion)[0]) {
            if (this.get_HighlightItemIndex() > 0 && (this.get_HighlightItemIndex() - 1) < eval(this._suggestion).length) {
                this._activeItem = this.get_HighlightItemIndex();
                this._setTextBoxValue();
                this._addListHover();
            }
            if (this.get_AutoFill())
                this._autoFill();
        }
    },
    Disable: function () {
        this.set_Disable(true);
        $("#" + this._ID).attr("disabled", "true");
        $("#" + this._ID + "_dropdownbutton").addClass("autocompleteDropDownDisabled");
    },
    Enable: function () {
        this.set_Disable(false);
        $("#" + this._ID).attr("disabled", "");
        $("#" + this._ID + "_dropdownbutton").removeClass("autocompleteDropDownDisabled");
    },
    Show: function () {
        $(this._mainDiv).css("display", "block");
    },
    Hide: function () {
        $(this._mainDiv).css("display", "none");
    },
    Open: function () {
        this._queryString = "";
        $(this._textBox).focus();
        if (this._proxySuggestion && this.get_AllowCache()) {
            this._suggestion = this._proxySuggestion;
            if (this.get_ClientSideTemplate())
                this.generate_Template();
            else
                this._OnResponse();
        }
        else {
            this._dropdownFlag = true;
        }
        this._suggestionListProperties();
    },
    Close: function () {
        this._hideResult();
    },
    _OnRequest: function () {
        this._addLoadingClass();
    },
    _OnResponse: function () {
        this._hideResult();
        if (this._suggestion) {
            /* Caching the suggestion data */
            if (this._dropdownFlag) {
                this._proxySuggestion = this._suggestion;
                this._dropdownFlag = false;
            }

            if (this.get_JSONMode())
                this.render_JSONData();
            else {
                $(this._wrapperDiv).append(this._suggestion);
                this._suggestionLength = $(this._suggestionID + " li").length;
                /* Setting the List Height, Width and Position*/
                this.set_listHeight();
                this.set_listWidth();
                this.set_listPosition();
                this._showResult();
            }
        } else {
            this._showNoSuggestion();
        }
    },
    get_Data: function (target) {
        // debugger;
        // Check if Mode is Get
        if (this.get_Mode()) {
            this._sendGetRequest();
        }
        else {
            // Request on POST method
            // Check if DataFetch Server
            if (!this.get_DataFetch() || this.get_ClientSideTemplate()) {
                this._sendAjaxRequest();
            }
            //DataFetch in Client Side
            else {
                /*Check if Data is availiable -- if not get the Data*/
                if (this._suggestion || this.get_DataSource()) {
                    //debugger;
                    this._suggestion = this.get_DataSource();
                    this._fetchData();
                }
                else
                    this._sendAjaxRequest();
            }
        }
    },
    /* Key up handler */
    _OnKeyUpHandler: function (e) {
        //Remove the Error Flag if exist
        if ($(this._textBox).hasClass("error"))
            $(this._textBox).removeClass("error");

        var target = e.target;
        var pointer = this;

        switch (e.keyCode) {
            case 38:    //Up arrow
                e.preventDefault();
                if ($(this._suggestionID)[0]) {
                    this._removeListHover();
                    if (this._activeItem > 1)
                        this._activeItem -= 1;
                    else
                        this._activeItem = this._listSize;
                    this._addListHover();
                    this._setTextBoxValue();
                }
                this._queryString = $("#" + this._ID).val();
                break;
            case 40:    //Down arrow
                e.preventDefault();
                if ($(this._suggestionID)[0]) {
                    this._removeListHover();
                    if (this._activeItem < this._listSize)
                        this._activeItem += 1;
                    else
                        this._activeItem = 1;
                    this._addListHover();
                    this._setTextBoxValue();
                }
                this._queryString = $("#" + this._ID).val();
                break;
            case 37:    //Left, Right, Enter Key
            case 39:
            case 13:
                //Do Nothing
                break;
            case 27:    //Esc key
                if ($(this._suggestionID)[0]) {
                    if (this._delimiterFlag)
                        $(this._textBox).val(this._wholeQuery.substr(0, this._delimiterIndex + 1) + this._queryString);
                    else
                        $(this._textBox).val(this._queryString);
                    this._hideResult();
                    /* Raise ClientSide Event*/
                    this._raiseEvents("ClientSideValueChange", e);
                }
                break;
            default:

                if (target == this.get_element()) {
                    // Index starts with "0"-Zero                    
                    var delimiterindex = (target.value).lastIndexOf(this.get_Delimiter());
                    this._wholeQuery = target.value;
                    var querylength = target.value.length;
                    this._delimiterFlag = 0;

                    /*Check Delimiter Conditions and current text*/
                    if (this.get_Delimiter() == null || delimiterindex == -1) {
                        this._queryString = target.value;
                    }
                    else if (delimiterindex + 1 == querylength) {
                        this._hideResult();
                        return false;
                    }
                    else {
                        this._delimiterFlag = 1;
                        this._delimiterIndex = delimiterindex;
                        this._queryLength = querylength;
                        this._queryString = (target.value).substr(delimiterindex + 1, querylength);
                    }

                    if (this._queryString.length >= this.get_MinCharacter()) {
                        clearTimeout(this._timeOut);
                        this._timeOut = setTimeout(function () {
                            if (pointer.get_DataSource() && pointer.get_DataFetch() && !pointer.get_ClientSideTemplate()) {
                                pointer._suggestion = pointer.get_DataSource();
                                pointer._fetchData();
                            }
                            else
                                pointer.get_Data(target);
                        }, this.get_Delay());
                    } else {
                        clearTimeout(this._timeOut);
                        this._hideResult();
                    }
                    /* Raise ClietnSide Event*/
                    this._raiseEvents("ClientSideValueChange", e);
                } else
                    this._hideResult();
                break;
        }
    },
    /* Key Down Handler */
    _OnKeyDownHandler: function (e) {
        if (this.get_AutoFill())
            if (e.keyCode == 8 || (e.keyCode >= 46 && e.keyCode <= 90) || (e.keyCode >= 97 && e.keyCode <= 105)) {
                if (this._queryString) {
                    $("#" + this._ID).val(this._wholeQuery);
                    if (!($.browser.msie == true && $.browser.version < 9)) {
                        $get(this._ID).setSelectionRange(this._wholeQuery.length, this._wholeQuery.length);
                    }
                }
            }
        //Enter key -- If list there stop the form submit
        if (e.keyCode == 13 || e.keyCode == 9) {
            if ($(this._suggestionID)[0]) {
                this._setTextBoxValue();
                this._raiseEvents("ClientSideOnSelect");
                this._hideResult();
                e.preventDefault();
            }
        }
    },
    /*Key Press Handler*/
    _OnKeyPressHandler: function (e) {
        if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
        else if (e.which) code = e.which; // ns4 and opera
        else code = e.charCode;
        if (this.get_AutoFill())
            if (e.keyCode == 8 || (e.keyCode >= 46 && e.keyCode <= 90) || (e.keyCode >= 97 && e.keyCode <= 105)) {
                if (this._queryString) {
                    $("#" + this._ID).val(this._wholeQuery);
                    if (!($.browser.msie == true && $.browser.version < 9)) {
                        $get(this._ID).setSelectionRange(this._wholeQuery.length, this._wholeQuery.length);
                    }
                }
            }
        if (code == 13) {
            e.preventDefault();
        }
    },
    /* DropDown click Handler */
    _OnDropDownHandler: function (e) {
        // debugger;
        var target = e.target;
        //Checking left click
        if (e.button == 0 && !this.get_Disable()) {
            if (target.parentNode.parentNode) {
                if ("#" + target.id == this._dropdownButton) {
                    //Checking Whether Suggestion List present
                    if ($(this._suggestionID)[0]) {
                        this._hideResult();
                    }
                    else {
                        this._queryString = "";
                        $(this._textBox).focus();
                        if (this._proxySuggestion && this.get_AllowCache()) {
                            this._suggestion = this._proxySuggestion;
                            if (this.get_ClientSideTemplate())
                                this.generate_Template();
                            else
                                this._OnResponse();

                        }
                        else {
                            this._dropdownFlag = true;
                            this.get_Data(target);
                        }
                    }
                    this._suggestionListProperties();
                }
                else {
                    this._hideResult();
                }
            }
        }
    },
    /* Mouse Click Handler */
    _OnClickHandler: function (e) {
        var target = e.target;
        if ("#" + target.id != this._dropdownButton) {
            this._hideResult();
        }
    },
    /* Mouse Over Handler */
    _OnMouseOverHandler: function (e) {
        var target = e.target;
        if (target.parentNode.parentNode) {
            this._removeListHover();
            if ("#" + target.parentNode.parentNode.id == this._suggestionID) {
                $(target).addClass("listHover");
                this._activeItem = $(this._suggestionListID).index(target) + 1;
            }
            else if ($(target).parents(this._suggestionListID)[0]) {
                this._activeItem = $(this._suggestionListID).index($(target).parents(this._suggestionListID)[0]) + 1;
                $($(target).parents(this._suggestionListID)[0]).addClass("listHover");
            }
        }
        if (this._FillOnMouseOver)
            this._setTextBoxValue();
    },
    /* Mouse Handler */
    _OnMouseOutHandler: function (e) {
        var target = e.target;
        if (target.parentNode.parentNode) {
            if ("#" + target.parentNode.parentNode.id == this._suggestionID) {
                this._removeListHover();
            }
            else if ($(target).parents(this._suggestionListID)[0]) {
                this._removeListHover();
            }
        }
    },
    /* Focus Handler */
    _OnFocusHandler: function (e) {
        if ($(this._textBox).hasClass("watermark")) {
            $(this._textBox).removeClass("watermark").val("");
        }
        /* Raise ClientSide Event*/
        this._raiseEvents("ClientSideFocusIn");
    },
    /* Blur Handler */
    _OnBlurHandler: function (e) {
        if (this.get_WaterMark() != null) {
            if ($(this._textBox).val() === '')
                $(this._textBox).addClass("watermark").val(this.get_WaterMark());
        }
        /* Raise ClientSide Event*/
        this._raiseEvents("ClientSideFocusOut", e);
    },
    /* Mouse Down Handler */
    _OnMouseDownHandler: function (e) {
        var target = e.target;
        //Checking left click
        if (e.button == 0) {
            if ("#" + target.parentNode.parentNode.id == this._suggestionID || $(target).parents(this._suggestionListID)[0]) {
                this._setTextBoxValue();
                if (this._suggestion)
                    this._queryString = $("#" + this._ID).val();
                this._raiseEvents("ClientSideOnSelect", e);
                this._hideResult();
            }
        }
    },
    /* Resize Handler */
    _OnResizeHandler: function (e) {
        this._hideResult();
    },
    /* Raise Client Side Events */
    _raiseEvents: function (eventName, oEv) {
        var handler = this.get_events().getHandler(eventName);
        if (handler) {
            var eventArgs = new Syncfusion.Mvc.Shared.AutocompleteTextBox.SelectEventArgs(eventName, oEv, $(this._textBox).val(), this._getActiveItem());
            if (!eventArgs) {
                eventArgs = Sys.EventArgs.Empty;
            }
            handler(this, eventArgs);
        }
    },
    _raiseEventRendering: function (eventName, suggestion, element) {
        var handler = this.get_events().getHandler(eventName);
        if (handler) {
            var eventArgs = new Syncfusion.Mvc.Shared.AutocompleteTextBox.EventRendering(eventName, suggestion, element);
            if (!eventArgs) {
                eventArgs = Sys.EventArgs.Empty;
            }
            handler(this, eventArgs);
        }
    },
    _raiseAjaxEvent: function (eventName, data) {
        var handler = this.get_events().getHandler(eventName);
        var eventArgs = new Syncfusion.Mvc.Shared.AutocompleteTextBox.AjaxEventArgs(eventName, data);
        if (handler) {
            if (!eventArgs) {
                eventArgs = Sys.EventArgs.Empty;
            }
            handler(this, eventArgs);
        }
    },
    /*Render suggestion list's outter div*/

    _renderSuggestionList: function () {
        var SuggestionList = $get(this._ID + "_suggestion_wrapper");
        if (SuggestionList) {
            $(SuggestionList).remove();
        }
        var suggestionWrapper = document.createElement("div");
        suggestionWrapper.id = this._ID + "_suggestion_wrapper";
        $("body").append(suggestionWrapper);
    },
    _showSuggestionList: function () {
        this._queryString = "";
        this._sendAjaxRequest();
    },
    _hideSuggestionList: function () {
        this._hideResult();
    },
    /* Bind the Events*/
    _wireEvents: function () {

        this._docclick = Function.createDelegate(this, this._OnClickHandler);
        $addHandler(document, 'click', this._docclick);

        this._wrapperIDclick = Function.createDelegate(this, this._OnDropDownHandler);
        $addHandler($get(this._wrapperID), 'click', this._wrapperIDclick);

        this._elementfoucs = Function.createDelegate(this, this._OnFocusHandler);
        $addHandler(this.get_element(), 'focus', this._elementfoucs);

        this._elementblur = Function.createDelegate(this, this._OnBlurHandler);
        $addHandler(this.get_element(), 'blur', this._elementblur);

        this._wrapperIDkeydown = Function.createDelegate(this, this._OnKeyDownHandler);
        $addHandler($get(this._wrapperID), 'keydown', this._wrapperIDkeydown);

        this._wrapperIDkeyup = Function.createDelegate(this, this._OnKeyUpHandler);
        $addHandler($get(this._wrapperID), 'keyup', this._wrapperIDkeyup);

        if ($.browser.opera) {

            this._wrapperIDkeypress = Function.createDelegate(this, this._OnKeyPressHandler);
            $addHandler($get(this._wrapperID), 'keypress', this._wrapperIDkeypress);
        }

        this._suggestionwrappermouseover = Function.createDelegate(this, this._OnMouseOverHandler);
        $addHandler(this._suggestionWrapper, 'mouseover', this._suggestionwrappermouseover);

        this._suggestionwrappermouseout = Function.createDelegate(this, this._OnMouseOutHandler);
        $addHandler(this._suggestionWrapper, 'mouseout', this._suggestionwrappermouseout);

        this._suggestionwrappermousedown = Function.createDelegate(this, this._OnMouseDownHandler);
        $addHandler(this._suggestionWrapper, 'mousedown', this._suggestionwrappermousedown);

        this._windowresize = Function.createDelegate(this, this._OnResizeHandler);
        $addHandler(window, 'resize', this._windowresize);
    },
    /* Clear the Events */
    _disposeEvents: function () {
        $removeHandler(document, 'click', this._docclick);
        $removeHandler(this.get_element(), 'focus', this._elementfoucs);
        $removeHandler(this.get_element(), 'blur', this._elementblur);
        $removeHandler(this._suggestionWrapper, 'mouseover', this._suggestionwrappermouseover);
        $removeHandler(this._suggestionWrapper, 'mouseout', this._suggestionwrappermouseout);
        $removeHandler(this._suggestionWrapper, 'mousedown', this._suggestionwrappermousedown);
        $removeHandler(window, 'resize', this._windowresize);
    }
}
Syncfusion.Mvc.Shared.AutocompleteTextBox.registerClass('Syncfusion.Mvc.Shared.AutocompleteTextBox', Sys.UI.Control);


if (typeof (Sys) != 'undefined') {
    Sys.Application.notifyScriptLoaded();
}

/* ClientSide EventArgs*/

Syncfusion.Mvc.Shared.AutocompleteTextBox.SelectEventArgs = function (eventName,oEV, value, activeitem) {
    this._eventName = eventName;
    this._event = oEV;
    this._value = value;
    this._activeitem = activeitem;
};

Syncfusion.Mvc.Shared.AutocompleteTextBox.SelectEventArgs.prototype = {
    get_Event: function () {
        return this._event;
    },
    get_Value: function () {
        return this._value;
    },
    get_ActiveItem: function () {
        return this._activeitem;
    },
    get_EventName: function () {
        return this._eventName;
    }
}


Syncfusion.Mvc.Shared.AutocompleteTextBox.SelectEventArgs.registerClass('Syncfusion.Mvc.Shared.AutocompleteTextBox.SelectEventArgs');

Syncfusion.Mvc.Shared.AutocompleteTextBox.AjaxEventArgs = function (eventName, data) {
    this._eventName = eventName;
    this._data = data;
};

Syncfusion.Mvc.Shared.AutocompleteTextBox.AjaxEventArgs.prototype = {
    get_Data: function () {
        return this._data;
    },
    get_EventName: function () {
        return this._eventName;
    }
}


Syncfusion.Mvc.Shared.AutocompleteTextBox.AjaxEventArgs.registerClass('Syncfusion.Mvc.Shared.AutocompleteTextBox.AjaxEventArgs');

Syncfusion.Mvc.Shared.AutocompleteTextBox.EventRendering = function (eventName, value, activeitem) {
    this._eventName = eventName;
    this._value = value;
    this._activeitem = activeitem;
};

Syncfusion.Mvc.Shared.AutocompleteTextBox.EventRendering.prototype = {
    get_Value: function () {
        return this._value;
    },
    get_ActiveItem: function () {
        return this._activeitem;
    },
    get_EventName: function () {
        return this._eventName;
    }
}
Syncfusion.Mvc.Shared.AutocompleteTextBox.EventRendering.registerClass('Syncfusion.Mvc.Shared.AutocompleteTextBox.SelectEventArgs');
